--[[
Creator Flangert_o https://aimware.net/forum/thread/143817
Recoding qi
]]
--gui
local x, y = draw.GetScreenSize()
local watermark = gui.Checkbox(gui.Reference("Misc", "General", "Extra"), "watermark", "Show Watermark", 0)
local x = gui.Slider(watermark, "x", "x", 1900, 0, x)
local y = gui.Slider(watermark, "y", "y", 10, 0, y)
local Grgb = gui.Checkbox(watermark, "rgb", "rgb", 0)
local Clr = gui.ColorPicker(watermark, "clr", "clr", 131, 109, 221, 255)
local Clr2 = gui.ColorPicker(watermark, "clr2", "clr", 0, 0, 0, 100)

watermark:SetDescription("Shows watermark AIMWARE.net.")
Grgb:SetInvisible(true)
x:SetInvisible(true)
y:SetInvisible(true)
--var
local font = draw.CreateFont("Verdana", 12)
local time, bTime, sTime = {0, 0, 0}, 0, 0
local tick = client.GetConVar("sv_maxcmdrate") .. " tick"
local renderer = {}

--function

renderer.text = function(x, y, clr, shadow, string, font, flags)
    local alpha = 255
    local textW, textH = draw.GetTextSize(string)

    if font ~= nil then
        draw.SetFont(font)
    end

    if clr[4] ~= nil then
        alpha = clr[4]
    end

    if flags == "c" then
        x = x - (textW / 2)
    elseif flags == "l" then
        x = x - textW
    elseif flags == "r" then
        x = x + textW
    end

    if shadow then
        draw.Color(0, 0, 0, alpha)
        draw.Text(x + 1, y + 1, string)
    end

    draw.Color(clr[1], clr[2], clr[3], alpha)
    draw.Text(x, y, string)
    alpha = nil
    x, y = nil
end

renderer.rectangle = function(x, y, w, h, clr, fill, radius)
    local alpha = 255

    if clr[4] ~= nil then
        alpha = clr[4]
    end

    draw.Color(clr[1], clr[2], clr[3], alpha)

    if fill then
        draw.FilledRect(x, y, x + w, y + h)
    else
        draw.OutlinedRect(x, y, x + w, y + h)
    end

    if fill == "shadow" then
        draw.ShadowRect(x, y, x + w, y + h, radius)
    end

    alpha = nil
end

renderer.gradient = function(x, y, w, h, clr, clr1, vertical)
    local r, g, b, a = clr1[1], clr1[2], clr1[3], clr1[4]
    local r1, g1, b1, a1 = clr[1], clr[2], clr[3], clr[4]

    if a and a1 == nil then
        a, a1 = 255, 255
    end

    if vertical then
        if clr[4] ~= 0 then
            if a1 and a ~= 255 then
                for i = 0, w do
                    local a2 = i / w * a1
                    renderer.rectangle(x, y + w - i, w, 1, {r1, g1, b1, a2}, true)
                end
            else
                renderer.rectangle(x, y, w, h, {r1, g1, b1, a1}, true)
            end
        end
        if a2 ~= 0 then
            for i = 0, h do
                local a2 = i / h * a
                renderer.rectangle(x, y + i, w, 1, {r, g, b, a2}, true)
            end
        end
    else
        if clr[4] ~= 0 then
            if a1 and a ~= 255 then
                for i = 0, w do
                    local a2 = i / w * a1
                    renderer.rectangle(x + w - i, y, 1, h, {r1, g1, b1, a2}, true)
                end
            else
                renderer.rectangle(x, y, w, h, {r1, g1, b1, a1}, true)
            end
        end
        if a2 ~= 0 then
            for i = 0, w do
                local a2 = i / w * a
                renderer.rectangle(x + i, y, 1, h, {r, g, b, a2}, true)
            end
        end
    end
    a, a1 = nil, nil
end

--rgb
local function hue2rgb(p, q, t)
    if (t < 0) then
        t = t + 1
    end
    if (t > 1) then
        t = t - 1
    end
    if (t < 1 / 6) then
        return p + (q - p) * 6 * t
    end
    if (t < 1 / 2) then
        return q
    end
    if (t < 2 / 3) then
        return p + (q - p) * (2 / 3 - t) * 6
    end
    return p
end
local function hslToRgb(h, s, l)
    local r, g, b

    if (s == 0) then
        r = l
        g = l
        b = l
    else
        local q = 0
        if (l < 0.5) then
            q = l * (1 + s)
        else
            q = l + s - l * s
        end

        local p = 2 * l - q

        r = hue2rgb(p, q, h + 1 / 3)
        g = hue2rgb(p, q, h)
        b = hue2rgb(p, q, h - 1 / 3)
    end
    return {r * 255, g * 255, b * 255}
end
local function Clamp(val, min, max)
    if (val > max) then
        return max
    elseif (val < min) then
        return min
    else
        return val
    end
end

--time
local function splitString(inputstr, sep)
    local t = {}
    for str in string.gmatch(inputstr, "([^" .. sep .. "]+)") do
        table.insert(t, str)
    end
    return t
end
callbacks.Register(
    "Draw",
    "getTime",
    function()
        if sTime == 0 or ((sTime + 1200 < common.Time()) and (entities.GetLocalPlayer() == nil or not entities.GetLocalPlayer():IsAlive())) then
            --local data = http.Get("https://time.is/Beijing")
            if data ~= nil then
                for i, str in pairs(splitString(string.match(data, [[<time id="clock">(.-)</time>]]), ":")) do
                    time[i] = tonumber(str)
                end
                sTime = common.Time()
            end
            bTime = common.Time()
        end
        time[3] = time[3] + common.Time() - bTime
        bTime = common.Time()
        if time[3] >= 60 then
            time[2], time[3], bTime = time[2] + 1, 0, common.Time()
        end
        if time[2] >= 60 then
            time[1], time[2] = time[1] + 1, 0
        end
        if time[1] >= 24 then
            time[1] = 0
        end
    end
)

--callbacks
callbacks.Register(
    "Draw",
    function()
        if not watermark:GetValue() then
            return
        end

        local lp = entities.GetLocalPlayer()
        local pr = entities.GetPlayerResources()

        --var
        local divider = " | "
        local cheatName = "aimware"
        local indexlp = client.GetLocalPlayerIndex()
        local userName = client.GetPlayerNameByIndex(indexlp)
        local server
        local delay
        local time =
            string.format(
            " %s:%s:%s",
            time[1] < 10 and "0" .. math.floor(time[1]) or math.floor(time[1]),
            time[2] < 10 and "0" .. math.floor(time[2]) or math.floor(time[2]),
            time[3] < 10 and "0" .. math.floor(time[3]) or math.floor(time[3])
        )
        if (lp ~= nil) then
            delay = "delay: " .. pr:GetPropInt("m_iPing", lp:GetIndex()) .. "ms"
            server = engine.GetServerIP()
        else
            userName = client.GetConVar("name")
            tick = client.GetConVar("sv_maxcmdrate") .. " tick"
        end
        local watermarkText = cheatName .. divider .. userName .. divider
        if server ~= nil then
            if (server == "loopback") then
                server = "localhost"
            elseif string.find(server, "A") then
                server = "valve"
            end
            watermarkText = watermarkText .. server .. divider
        end
        if delay ~= nil then
            watermarkText = watermarkText .. delay .. divider
        end
        local watermarkText = watermarkText .. tick .. divider .. time

        draw.SetFont(font)
        local w, h = draw.GetTextSize(watermarkText)
        local x, y = x:GetValue(), y:GetValue()
        local x = x - w
        local r, g, b, a = 255, 255, 255, 255
        local r2, g2, b2, a2 = Clr:GetValue()
        local r3, g3, b3, a3 = Clr2:GetValue()
        local rgb = hslToRgb((globals.CurTime() / Clamp(100 - 95, 1, 100)) % 1, 1, 0.5)

        renderer.rectangle(x, y + 2, w + 10, 18, {r3, g3, b3, a3}, true)

        if Grgb:GetValue() then
            renderer.gradient(x, y, w + 9, 2, {rgb[1], rgb[2], rgb[3], 255}, {rgb[2], rgb[3], rgb[1], 255}, nil)
        else
            renderer.rectangle(x, y, w + 10, 2, {r2, g2, b2, a2}, true)
        end

        renderer.text(x + 5, y + 6, {r, g, b, a}, nil, watermarkText, font)
        renderer.text(x + 5, y + 6, {r, g, b, a}, nil, watermarkText, font)
    end
)
--end
